/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	rt_config.h

	Abstract:
	Central header file to maintain all include files for all NDIS
	miniport driver routines.

	Revision History:
	Who		When		  What
	--------	----------	  -----------------------------------
	Rory Chen	12-21-2002	  created
	MarkW		09-02-2004	  Baseline of code

*/

#ifndef	__RT_CONFIG_H__
#define	__RT_CONFIG_H__

#define	DRV_NAME	"rt2400"
#define DRV_VERSION	"1.1.1"
#define DRV_RELDATE	"2003/02/22"
#define	PROFILE_PATH	"/etc/Ralink/RT2400/RT2400.dat"

/* Operational parameters that are set at compile time. */
#if !defined(__OPTIMIZE__)  ||  !defined(__KERNEL__)
#warning  You must compile this file with the correct options!
#warning  See the last lines of the source file.
#error  You must compile this driver with "-O".
#endif

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <linux/errno.h>
#include <linux/ioport.h>
#include <linux/slab.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/ethtool.h>
#include <linux/wireless.h>
#include <linux/proc_fs.h>
#include <linux/delay.h>
#include <linux/if_arp.h>

#if LINUX_VERSION_CODE >= 0x20407
#include <linux/mii.h>
#endif
#include <asm/processor.h>		/* Processor type for cache alignment. */
#include <asm/bitops.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/uaccess.h>

// The type definition has to be placed before including rt2460.h
#ifndef ULONG
#define	CHAR			char
#define	INT				int
#define	UINT			u32
#define ULONG			u32
#define USHORT			u16
#define UCHAR			u8

#define BOOLEAN			u8
#define LARGE_INTEGER	s64
#define VOID			void
#define	LONG			int
#define ULONGLONG		u64
typedef VOID	*PVOID;
typedef CHAR	*PCHAR;
typedef UCHAR	*PUCHAR;
typedef LONG	*PLONG;
#endif

#define	IN
#define	OUT

#define TRUE		1
#define FALSE		0

#define ETH_LENGTH_OF_ADDRESS	6

#define	NDIS_STATUS				INT
#define	NDIS_STATUS_SUCCESS		0x00
#define NDIS_STATUS_FAILURE		0x01
#define	NDIS_STATUS_RESOURCES	0x03

#include	"rt2460.h"
#include	"rtmp_def.h"
#include	"rtmp.h"
#include	"mlme.h"
#include	"oid.h"

#endif	// __RT_CONFIG_H__
