/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	cardselect.h

	Abstract:
	Implement card select Dialog.

	Revision History:
	Who		When		  What
	--------	----------	  -----------------------------------
	Paul Wu		01-22-2003	  created
	MarkW		09-02-2004	  Baseline of code

*/

#ifndef CARDSELECT_H
#define CARDSELECT_H

#include <qvariant.h>
#include <qdialog.h>
#include <rt_tool.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;


class CardSelect : public QDialog
{ 
	Q_OBJECT

public:
	CardSelect( int Socket_Id = 0, PRT_DEVICE_ADAPTER prtAdapter = NULL, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~CardSelect();

	QPushButton* OkPushButton;
	QListView* AdapterListView;
	QLabel* TextLabel1;
	QString    device;
	const char	*Get_Device_Name();

public slots:	

	virtual void AdapterListView_doubleClicked();
	virtual void OkPushButton_Clicked();
};

#endif // CARDSELECT_H
