/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	configapi.h

	Abstract:
	Implement getkeystring / writekeystring like windows API.

	Revision History:
	Who		When		  What
	--------	----------	  ----------------------------------
	Paul Wu		01-22-2003	  created
	MarkW		09-02-2004	  Baseline of code

*/

#ifndef _CONFIGAPI_H
#define _CONFIGAPI_H

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX_CHARS 256          // Maximum characters/line in Configuration File.
#define NEWLINE   "\n"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

int isfound(char *ptr, char *ini_buffer);
char *find_header(char *ini_buffer, char *header_name);
int get_parameter(char *str, int strsize, char *key, char *offset);
char *find_parameter(char *key, char *offset, int *length);
int writekeystring(char *section, char *key, char *str, char *path, char *filename);
int getkeystring(char *section, char *key, char *dest, int strsize, char *path, char *filename);

#endif //_CONFIGAPI_H
