/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	countryform.h

	Abstract:
	Implement Country Region Select Dialog.

	Revision History:
	Who		When		  What
	--------	----------	  -----------------------------------
	Paul Wu		01-22-2003	  created
	MarkW		09-02-2004	  Baseline of code

*/


#ifndef _COUNTRYFROM_H
#define _COUNTRYFROM_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QLabel;
class QPushButton;
class QRadioButton;

class CountryForm : public QDialog
{ 
	Q_OBJECT

public:
	CountryForm( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~CountryForm();

	QLabel* InfoTextLabel;
	QPushButton* OkPushButton;
	QPushButton* CancelPushButton;
	QButtonGroup* SelectButtonGroup;
	QRadioButton* ISRAELRadioButton;
	QRadioButton* ICRadioButton;
	QRadioButton* ETSIRadioButton;
	QRadioButton* MKKRadioButton;
	QRadioButton* MKK1RadioButton;
	QRadioButton* SPAINRadioButton;
	QRadioButton* FCCRadioButton;

	int GetRegionID();
};

#endif //_COUNTRYFROM_H

