/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	qhexvalidator.cpp

	Abstract:
	Implement hex validator for WEP security.

	Revision History:
	Who		When		  What
	--------	----------	  ---------------------------------
	Paul Wu		01-22-2003	  created
	MarkW		09-02-2004	  Baseline of code
	MarkW		22-02-2004	  Added malloc.h include 

*/


#include <qvalidator.h>
#include <qwidget.h>
#include <malloc.h>

#include "qhexvalidator.h"

QHexValidator::QHexValidator ( QWidget * parent, const char * name )
  : QValidator(parent, name)
{

}

QHexValidator::~QHexValidator()
{}

QValidator::State QHexValidator::validate ( QString &str, int &pos ) const
{
	char *tmp;
	char ch;
	unsigned int i;
	bool ok=FALSE;

	if(str.length() == 0)
		return QValidator::Acceptable;

	tmp = (char *)malloc(str.length()+1);	
	if(!tmp)
		return QValidator::Invalid;
	strcpy(tmp, str.data());
	for(i=0; i<str.length(); i++)
	{
		ch = *(tmp+i);		
		if( ((ch >= 'a') && (ch <= 'f')) || ((ch >= 'A') && (ch <= 'F')) ||
		  ((ch >= '0') && (ch <= '9')) )
		{
			ok=TRUE;
		}
		else
		{
			ok=FALSE;
			break;
		}
	}

	//free(tmp);
	if(ok)
	{
		return QValidator::Acceptable;
	}
	else
	{
		return QValidator::Invalid;
	}
	pos=0; //avoid compile warning

}


