/****************************************************************************
 * rt2400 Linux Driver
 * http://rt2400.sourceforge.net
 * Refer to the LICENSE file for code license
 *
 * Parts of this source were from original RaLink drivers.
 ****************************************************************************

	Module Name:
	sitewepdlg.h

	Abstract:
	Implement WEP dialog for connecting when AP enable WEP.

	Revision History:
	Who		When		  What
	--------	----------	  -----------------------------------
	Paul Wu		01-22-2003	  created
	MarkW		09-02-2004	  Baseline of code

*/

#ifndef SITEWEPDLG_H
#define SITEWEPDLG_H

#include <qvariant.h>
#include <qdialog.h>

#include "qhexvalidator.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QCheckBox;
class QComboBox;
class QFrame;
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;

class SiteWepDlg : public QDialog
{ 
	Q_OBJECT

public:
	SiteWepDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~SiteWepDlg();

	QFrame* Frame5;
	QButtonGroup* ButtonGroup3;
	QLabel* TextLabel10_2;
	QComboBox* WepAuthenticationComboBox;
	QButtonGroup* ButtonGroup4;
	QLabel* TextLabel11_2;
	QLabel* TextLabel12_2;
	QButtonGroup* ButtonGroup5_2;
	QRadioButton* WepKey1RadioButton;
	QRadioButton* WepKey2RadioButton;
	QRadioButton* WepKey3RadioButton;
	QRadioButton* WepKey4RadioButton;
	QLineEdit* WepKey1LineEdit;
	QLineEdit* WepKey2LineEdit;
	QLineEdit* WepKey3LineEdit;
	QLineEdit* WepKey4LineEdit;
	QComboBox* WepWEPKeyTypeComboBox;
	QComboBox* WepWEPKeyLengthComboBox;
	QCheckBox* EncryptionCheckBox;
	QPushButton* WepOkPushButton;
	QPushButton* WepCancelPushButton;

	QHexValidator  *hexValidator;	 
	bool  isWepOk;

	int	 Get_Wep_KeyID();
	int  Get_Wep_KeyLength();
	int  Get_Wep_KeyType();
	const char *Get_Wep_KeyString(int index);
	void m_ChangeAuthType(int type);   //0: open system,  1: shared key
	void m_EnableAuthType(bool bFlag);
	int  m_GetWepAuthenType();
	bool m_IsClickWepOkButton();

public slots:	
	virtual	void WepOkPushButton_Click();
	virtual	void WepCancelPushButton_Click();
	virtual	void EncryptionCheckBox_toggled(bool);
	virtual	void WepWEPKeyTypeComboBox_activated(int);
	virtual	void WepWEPKeyLengthComboBox_activated(int);
};

#endif // SITEWEPDLG_H
